



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>伙伴系统之伙伴系统概述--Linux内存管理(十五)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">伙伴系统之伙伴系统概述--Linux内存管理(十五)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-21 10:15:09 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>在内核初始化完成之后, 内存管理的责任就由伙伴系统来承担. 伙伴系统基于一种相对简单然而令人吃惊的强大算法.</p>
<p>Linux内核使用二进制伙伴算法来管理和分配物理内存页面, 该算法由Knowlton设计, 后来Knuth又进行了更深刻的描述.</p>
<p>伙伴系统是一个结合了2的方幂个分配器和空闲缓冲区合并计技术的内存分配方案, 其基本思想很简单. 内存被分成含有很多页面的大块, 每一块都是2个页面大小的方幂. 如果找不到想要的块, 一个大块会被分成两部分, 这两部分彼此就成为伙伴. 其中一半被用来分配, 而另一半则空闲. 这些块在以后分配的过程中会继续被二分直至产生一个所需大小的块. 当一个块被最终释放时, 其伙伴将被检测出来, 如果伙伴也空闲则合并两者.</p>
<ul><li>内核如何记住哪些内存块是空闲的</li>
<li>分配空闲页面的方法</li>
<li>影响分配器行为的众多标识位</li>
<li>内存碎片的问题和分配器如何处理碎片</li></ul>
<h2>2 伙伴系统的结构</h2>
<h3>2.1 伙伴系统数据结构</h3>
<p>系统内存中的每个物理内存页（页帧），都对应于一个struct page实例, 每个内存域都关联了一个struct zone的实例，其中保存了用于管理伙伴数据的主要数数组</p>
<pre class="prettyprint linenums"><code>//  http://lxr.free-electrons.com/source/include/linux/mmzone.h?v=4.7#L324<br />
struct zone<br />
{<br />
     /* free areas of different sizes */<br />
    struct free_area        free_area[MAX_ORDER];<br />
};<br />
</code></pre>
<p>struct free_area是一个伙伴系统的辅助数据结构, 它定义在<a href="http://lxr.free-electrons.com/source/include/linux/mmzone.h?v=4.7#L88" rel="external nofollow noreferrer">include/linux/mmzone.h?v=4.7, line 88</a></p>
<pre class="prettyprint linenums"><code>struct free_area {<br />
    struct list_head        free_list[MIGRATE_TYPES];<br />
    unsigned long           nr_free;<br />
};<br />
</code></pre>
<table>
<thead>
<tr>
<th>字段</th>
<th>描述</th>
</tr>
</thead>
<tbody>
<tr>
<td>free_list</td>
<td>是用于连接空闲页的链表. 页链表包含大小相同的连续内存区</td>
</tr>
<tr>
<td>nr_free</td>
<td>指定了当前内存区中空闲页块的数目（对0阶内存区逐页计算，对1阶内存区计算页对的数目，对2阶内存区计算4页集合的数目，依次类推</td>
</tr>
</tbody>
</table>
<p>伙伴系统的分配器维护空闲页面所组成的块, 这里每一块都是2的方幂个页面, 方幂的指数称为阶.</p>
<p>阶是伙伴系统中一个非常重要的术语. 它描述了内存分配的数量单位. 内存块的长度是2^0,order , 其中order的范围从0到MAX_ORDER</p>
<p>zone-&gt;free_area[MAX_ORDER]数组中阶作为各个元素的索引, 用于指定对应链表中的连续内存区包含多少个页帧.</p>
<ul><li>数组中第0个元素的阶为0, 它的free_list链表域指向具有包含区为单页(2^0 = 1)的内存页面链表</li>
<li>数组中第1个元素的free_list域管理的内存区为两页(2^1 = 2)</li>
<li>第3个管理的内存区为4页, 依次类推.</li>
<li>直到 2^MAXORDER-1个页面大小的块</li></ul>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/811006/201812/811006-20181208210735212-1304032913.png"></p>
<h3>2.2 最大阶MAX_ORDER与FORCE_MAX_ZONEORDER配置选项</h3>
<p>一般来说<code>MAX_ORDER</code>默认定义为11, 这意味着一次分配可以请求的页数最大是2^11=2048, 参见<a href="http://lxr.free-electrons.com/source/include/linux/mmzone.h?v=4.7#L22" rel="external nofollow noreferrer">include/linux/mmzone.h?v=4.7, line 22</a></p>
<pre class="prettyprint linenums"><code>/* Free memory management - zoned buddy allocator.  */<br />
#ifndef CONFIG_FORCE_MAX_ZONEORDER<br />
#define MAX_ORDER 11<br />
#else<br />
#define MAX_ORDER CONFIG_FORCE_MAX_ZONEORDER<br />
#endif<br />
#define MAX_ORDER_NR_PAGES (1 &lt;&lt; (MAX_ORDER - 1))<br />
</code></pre>
<p>但如果特定于体系结构的代码设置了<code>FORCE_MAX_ZONEORDER</code>配置选项, 该值也可以手工改变</p>
<p>例如，IA-64系统上巨大的地址空间可以处理<code>MAX_ORDER = 18</code>的情形，而ARM或v850系统则使用更小的值(如8或9). 但这不一定是由计算机支持的内存数量比较小引起的，也可能是内存对齐方式的要求所导致</p>
<p>可以参考一些架构的Kconfig文件如下</p>
<table>
<thead>
<tr>
<th>arm</th>
<th>arm64</th>
</tr>
</thead>
<tbody>
<tr>
<td><a href="http://lxr.free-electrons.com/source/arch/arm/Kconfig?v=4.7#L1696" rel="external nofollow noreferrer">arch/arm/Kconfig?v=4.7, line 1696</a></td>
<td><a href="http://lxr.free-electrons.com/source/arch/arm64/Kconfig?v=4.7#L679" rel="external nofollow noreferrer">arch/arm64/Kconfig?v=4.7, line 679</a></td>
</tr>
</tbody>
</table>
<p>比如<a href="https://elixir.bootlin.com/linux/v4.7/source/arch/arm64/Kconfig#L679" rel="external nofollow noreferrer">arm64体系结构的Kconfig配置文件的描述</a></p>
<pre class="prettyprint linenums"><code>config FORCE_MAX_ZONEORDER<br />
int<br />
default &quot;14&quot; if (ARM64_64K_PAGES &amp;&amp; TRANSPARENT_HUGEPAGE)<br />
default &quot;12&quot; if (ARM64_16K_PAGES &amp;&amp; TRANSPARENT_HUGEPAGE)<br />
default &quot;11&quot;<br />
</code></pre>
<h3>2.3 内存区是如何连接的</h3>
<p>内存区中第1页内的链表元素, 可用于将内存区维持在链表中。因此，也不必引入新的数据结构来管理物理上连续的页，否则这些页不可能在同一内存区中. 如下图所示</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/811006/201812/811006-20181208211344591-49182426.png"></p>
<p>伙伴不必是彼此连接的. 如果一个内存区在分配其间分解为两半, 内核会自动将未用的一半加入到对应的链表中.</p>
<p>如果在未来的某个时刻, 由于内存释放的缘故, 两个内存区都处于空闲状态, 可通过其地址判断其是否为伙伴. 管理工作较少, 是伙伴系统的一个主要优点.</p>
<p>基于伙伴系统的内存管理专注于某个结点的某个内存域, 例如, DMA或高端内存域. 但所有内存域和结点的伙伴系统都通过备用分配列表连接起来.</p>
<p>下图说明了这种关系.</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/811006/201812/811006-20181208211624464-1196023312.png"></p>
<p>最后要注意, 有关伙伴系统和当前状态的信息可以在/proc/buddyinfo中获取</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/811006/201812/811006-20181208211701942-784617904.png"></p>
<p>内核中很多时候要求分配连续页. 为快速检测内存中的连续区域, 内核采用了一种古老而历经检验的技术: 伙伴系统</p>
<p>系统中的空闲内存块总是两两分组, 每组中的两个内存块称作伙伴. 伙伴的分配可以是彼此独立的. 但如果两个伙伴都是空闲的, 内核会将其合并为一个更大的内存块, 作为下一层次上某个内存块的伙伴.</p>
<p>下图示范了该系统, 图中给出了一对伙伴, 初始大小均为8页. 即系统中所有的页面都是8页的.</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/811006/201812/811006-20181209104618884-1082248846.png"></p>
<p>内核对所有大小相同的伙伴（1、2、4、8、16或其他数目的页），都放置到同一个列表中管理. 各有8页的一对伙伴也在相应的列表中.</p>
<p>如果系统现在需要8个页帧, 则将16个页帧组成的块拆分为两个伙伴. 其中一块用于满足应用程序的请求, 而剩余的8个页帧则放置到对应8页大小内存块的列表中.</p>
<p>如果下一个请求只需要2个连续页帧, 则由8页组成的块会分裂成2个伙伴, 每个包含4个页帧. 其中一块放置回伙伴列表中，而另一个再次分裂成2个伙伴, 每个包含2页。其中一个回到伙伴系统，另一个则传递给应用程序.</p>
<p>在应用程序释放内存时, 内核可以直接检查地址, 来判断是否能够创建一组伙伴, 并合并为一个更大的内存块放回到伙伴列表中, 这刚好是内存块分裂的逆过程。这提高了较大内存块可用的可能性.</p>
<p>在系统长期运行时，服务器运行几个星期乃至几个月是很正常的，许多桌面系统也趋向于长期开机运行，那么会发生称为碎片的内存管理问题。频繁的分配和释放页帧可能导致一种情况：系统中有若干页帧是空闲的，但却散布在物理地址空间的各处。换句话说，系统中缺乏连续页帧组成的较大的内存块，而从性能上考虑，却又很需要使用较大的连续内存块。通过伙伴系统可以在某种程度上减少这种效应，但无法完全消除。如果在大块的连续内存中间刚好有一个页帧分配出去，很显然这两块空闲的内存是无法合并的.</p>
<p>在内核版本2.6.24之后, 增加了一些有效措施来防止内存碎片.</p>
<h2>3 避免碎片</h2>
<p>在第1章给出的简化说明中, 一个双链表即可满足伙伴系统的所有需求. 在内核版本2.6.23之前, 的确是这样. 但在内核2.6.24开发期间, 内核开发者对伙伴系统的争论持续了相当长时间. 这是因为伙伴系统是内核最值得尊敬的一部分，对它的改动不会被大家轻易接受</p>
<h3>3.1 内存碎片</h3>
<p>伙伴系统的基本原理已经在第1章中讨论过，其方案在最近几年间确实工作得非常好。但在Linux内存管理方面，有一个长期存在的问题：在系统启动并长期运行后，物理内存会产生很多碎片。该情形如下图所示</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/811006/201812/811006-20181209104948138-21221359.png"></p>
<p>假定内存由60页组成，这显然不是超级计算机，但用于示例却足够了。左侧的地址空间中散布着空闲页。尽管大约25%的物理内存仍然未分配，但最大的连续空闲区只有一页. 这对用户空间应用程序没有问题：其内存是通过页表映射的，无论空闲页在物理内存中的分布如何，应用程序看到的内存 似乎总是连续的。右图给出的情形中，空闲页和使用页的数目与左图相同，但所有空闲页都位于一个连续区中。</p>
<p>但对内核来说，碎片是一个问题. 由于(大多数)物理内存一致映射到地址空间的内核部分, 那么在左图的场景中, 无法映射比一页更大的内存区. 尽管许多时候内核都分配的是比较小的内存, 但也有时候需要分配多于一页的内存. 显而易见, 在分配较大内存的情况下, 右图中所有已分配页和空闲页都处于连续内存区的情形，是更为可取的.</p>
<p>很有趣的一点是, 在大部分内存仍然未分配时, 就也可能发生碎片问题. 考虑图3-25的情形.</p>
<p>只分配了4页，但可分配的最大连续区只有8页，因为伙伴系统所能工作的分配范围只能是2的幂次.</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/811006/201812/811006-20181209105419810-2040212750.png"></p>
<p>我提到内存碎片只涉及内核，这只是部分正确的。大多数现代CPU都提供了使用巨型页的可能性，比普通页大得多。这对内存使用密集的应用程序有好处。在使用更大的页时，地址转换后备缓冲器只需处理较少的项，降低了TLB缓存失效的可能性。但分配巨型页需要连续的空闲物理内存！</p>
<p>很长时间以来，物理内存的碎片确实是Linux的弱点之一。尽管已经提出了许多方法，但没有哪个方法能够既满足Linux需要处理的各种类型工作负荷提出的苛刻需求，同时又对其他事务影响不大。</p>
<h3>3.2 依据可移动性组织页</h3>
<p>在内核2.6.24开发期间，防止碎片的方法最终加入内核。在我讨论具体策略之前，有一点需要澄清。</p>
<p>文件系统也有碎片，该领域的碎片问题主要通过碎片合并工具解决。它们分析文件系统，重新排序已分配存储块，从而建立较大的连续存储区. 理论上，该方法对物理内存也是可能的，但由于许多物理内存页不能移动到任意位置，阻碍了该方法的实施。因此，内核的方法是反碎片(anti-fragmentation), 即试图从最初开始尽可能防止碎片.</p>
<p><strong>反碎片的工作原理如何?</strong></p>
<p>为理解该方法，我们必须知道内核将已分配页划分为下面3种不同类型。</p>
<table>
<thead>
<tr>
<th>页面类型</th>
<th>描述</th>
<th>举例</th>
</tr>
</thead>
<tbody>
<tr>
<td>不可移动页</td>
<td>在内存中有固定位置, 不能移动到其他地方.</td>
<td>核心内核分配的大多数内存属于该类别</td>
</tr>
<tr>
<td>可移动页</td>
<td>可以随意地移动.	属于用户空间应用程序的页属于该类别.</td>
<td>它们是通过页表映射的<br>如果它们复制到新位置，页表项可以相应地更新，应用程序不会注意到任何事</td>
</tr>
<tr>
<td>可回收页</td>
<td>不能直接移动, 但可以删除, 其内容可以从某些源重新生成.</td>
<td>例如，映射自文件的数据属于该类别<br>kswapd守护进程会根据可回收页访问的频繁程度，周期性释放此类内存. , 页面回收本身就是一个复杂的过程. 内核会在可回收页占据了太多内存时进行回收, 在内存短缺(即分配失败)时也可以发起页面回收.</td>
</tr>
</tbody>
</table>
<p>页的可移动性，依赖该页属于3种类别的哪一种. 内核使用的反碎片技术, 即基于将具有相同可移动性的页分组的思想.</p>
<p><strong>为什么这种方法有助于减少碎片?</strong></p>
<p>由于页无法移动, 导致在原本几乎全空的内存区中无法进行连续分配. 根据页的可移动性, 将其分配到不同的列表中, 即可防止这种情形. 例如, 不可移动的页不能位于可移动内存区的中间, 否则就无法从该内存区分配较大的连续内存块.</p>
<p>想一下, 上图中大多数空闲页都属于可回收的类别, 而分配的页则是不可移动的. 如果这些页聚集到两个不同的列表中, 如下图所示. 在不可移动页中仍然难以找到较大的连续空闲空间, 但对可回收的页, 就容易多了.</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/811006/201812/811006-20181209110338197-1658187097.png"></p>
<p>但要注意, 从最初开始, 内存并未划分为可移动性不同的区. 这些是在运行时形成的. 内核的另一种方法确实将内存分区, 分别用于可移动页和不可移动页的分配, 我会下文讨论其工作原理. 但这种划分对这里描述的方法是不必要的</p>
<h3>3.3 避免碎片数据结构</h3>
<h4>3.3.1 迁移类型</h4>
<p>尽管内核使用的反碎片技术卓有成效，它对伙伴分配器的代码和数据结构几乎没有影响。内核定义了一些枚举常量(早期用宏来实现)来表示不同的迁移类型, 参见<a href="http://lxr.free-electrons.com/source/include/linux/mmzone.h?v=4.7#L38" rel="external nofollow noreferrer">include/linux/mmzone.h?v=4.7, line 38</a></p>
<pre class="prettyprint linenums"><code>enum {<br />
        MIGRATE_UNMOVABLE,<br />
        MIGRATE_MOVABLE,<br />
        MIGRATE_RECLAIMABLE,<br />
        MIGRATE_PCPTYPES,       /* the number of types on the pcp lists */<br />
        MIGRATE_HIGHATOMIC = MIGRATE_PCPTYPES,<br />
#ifdef CONFIG_CMA<br />
        /*<br />
         * MIGRATE_CMA migration type is designed to mimic the way<br />
         * ZONE_MOVABLE works.  Only movable pages can be allocated<br />
         * from MIGRATE_CMA pageblocks and page allocator never<br />
         * implicitly change migration type of MIGRATE_CMA pageblock.<br />
         *<br />
         * The way to use it is to change migratetype of a range of<br />
         * pageblocks to MIGRATE_CMA which can be done by<br />
         * __free_pageblock_cma() function.  What is important though<br />
         * is that a range of pageblocks must be aligned to<br />
         * MAX_ORDER_NR_PAGES should biggest page be bigger then<br />
         * a single pageblock.<br />
         */<br />
        MIGRATE_CMA,<br />
#endif<br />
#ifdef CONFIG_MEMORY_ISOLATION<br />
        MIGRATE_ISOLATE,        /* can't allocate from here */<br />
#endif<br />
        MIGRATE_TYPES<br />
};<br />
</code></pre>
<table>
<thead>
<tr>
<th>宏</th>
<th>类型</th>
</tr>
</thead>
<tbody>
<tr>
<td>MIGRATE_UNMOVABLE</td>
<td>不可移动页</td>
</tr>
<tr>
<td>MIGRATE_MOVABLE</td>
<td>可移动页</td>
</tr>
<tr>
<td>MIGRATE_RECLAIMABLE</td>
<td>可回收页</td>
</tr>
<tr>
<td>MIGRATE_PCPTYPES</td>
<td>是per_cpu_pageset, 即用来表示每CPU页框高速缓存的数据结构中的链表的迁移类型数目</td>
</tr>
<tr>
<td>MIGRATE_HIGHATOMIC</td>
<td>在罕见的情况下，内核需要分配一个高阶的页面块而不能休眠.如果向具有特定可移动性的列表请求分配内存失败，这种紧急情况下可从MIGRATE_HIGHATOMIC中分配内存</td>
</tr>
<tr>
<td>MIGRATE_CMA</td>
<td>Linux内核最新的连续内存分配器(CMA), 用于避免预留大块内存</td>
</tr>
<tr>
<td>MIGRATE_ISOLATE</td>
<td>是一个特殊的虚拟区域, 用于跨越NUMA结点移动物理内存页. 在大型系统上, 它有益于将物理内存页移动到接近于使用该页最频繁的CPU.</td>
</tr>
<tr>
<td>MIGRATE_TYPES</td>
<td>只是表示迁移类型的数目, 也不代表具体的区域</td>
</tr>
</tbody>
</table>
<p>对于MIGRATE_CMA类型, 其中在我们使用ARM等嵌入式Linux系统的时候, 一个头疼的问题是GPU, Camera, HDMI等都需要预留大量连续内存，这部分内存平时不用，但是一般的做法又必须先预留着. 目前, Marek Szyprowski和Michal Nazarewicz实现了一套全新的Contiguous Memory Allocator. 通过这套机制, 我们可以做到不预留内存，这些内存平时是可用的，只有当需要的时候才被分配给Camera，HDMI等设备. 参照<a href="http://blog.51cto.com/21cnbao/898846" rel="external nofollow noreferrer">宋宝华–Linux内核最新的连续内存分配器(CMA)——避免预留大块内存</a>, 内核为此提供了函数is_migrate_cma来检测当前类型是否为MIGRATE_CMA, 该函数定义在<a href="https://elixir.bootlin.com/linux/v4.7/source/include/linux/mmzone.h#L69" rel="external nofollow noreferrer">include/linux/mmzone.h?v=4.7, line 69</a></p>
<pre class="prettyprint linenums"><code>/* In mm/page_alloc.c; keep in sync also with show_migration_types() there */<br />
extern char * const migratetype_names[MIGRATE_TYPES];

#ifdef CONFIG_CMA<br />
#  define is_migrate_cma(migratetype) unlikely((migratetype) == MIGRATE_CMA)<br />
#else<br />
#  define is_migrate_cma(migratetype) false<br />
#endif<br />
</code></pre>
<p>对伙伴系统数据结构的主要调整, 是将空闲列表分解为MIGRATE_TYPE个列表, 可以参见free_area的定义<a href="https://elixir.bootlin.com/linux/v4.7/source/include/linux/mmzone.h#L88" rel="external nofollow noreferrer">include/linux/mmzone.h?v=4.7, line 88</a></p>
<pre class="prettyprint linenums"><code>struct free_area<br />
{<br />
    struct list_head        free_list[MIGRATE_TYPES];<br />
    unsigned long           nr_free;<br />
};<br />
</code></pre>
<ul><li>nr_free统计了所有列表上空闲页的数目，而每种迁移类型都对应于一个空闲列表</li></ul>
<p>宏for_each_migratetype_order(order, type)可用于迭代指定迁移类型的所有分配阶</p>
<pre class="prettyprint linenums"><code>#define for_each_migratetype_order(order, type) \<br />
        for (order = 0; order &lt; MAX_ORDER; order++) \<br />
                for (type = 0; type &lt; MIGRATE_TYPES; type++)<br />
</code></pre>
<h4>3.3.2 迁移备用列表fallbacks</h4>
<p><strong>如果内核无法满足针对某一给定迁移类型的分配请求, 会怎么样?</strong></p>
<p>此前已经出现过一个类似的问题, 即特定的NUMA内存域无法满足分配请求时. 我们需要从其他内存域中选择一个代价最低的内存域完成内存的分配, 因此内核在内存的结点pg_data_t中提供了一个备用内存域列表zonelists.</p>
<p>内核在内存迁移的过程中处理这种情况下的做法是类似的. 提供了一个备用列表fallbacks, 规定了在指定列表中无法满足分配请求时. 接下来应使用哪一种迁移类型, 定义在<a href="https://elixir.bootlin.com/linux/v4.7/source/mm/page_alloc.c#L1799" rel="external nofollow noreferrer">mm/page_alloc.c?v=4.7, line 1799</a></p>
<pre class="prettyprint linenums"><code>/*<br />
 * This array describes the order lists are fallen back to when<br />
 * the free lists for the desirable migrate type are depleted<br />
 * 该数组描述了指定迁移类型的空闲列表耗尽时<br />
 * 其他空闲列表在备用列表中的次序<br />
 */<br />
static int fallbacks[MIGRATE_TYPES][4] = {<br />
    //  分配不可移动页失败的备用列表<br />
    [MIGRATE_UNMOVABLE]   = { MIGRATE_RECLAIMABLE, MIGRATE_MOVABLE,   MIGRATE_TYPES },<br />
    //  分配可回收页失败时的备用列表<br />
    [MIGRATE_RECLAIMABLE] = { MIGRATE_UNMOVABLE,   MIGRATE_MOVABLE,   MIGRATE_TYPES },<br />
    //  分配可移动页失败时的备用列表<br />
    [MIGRATE_MOVABLE]     = { MIGRATE_RECLAIMABLE, MIGRATE_UNMOVABLE, MIGRATE_TYPES },<br />
#ifdef CONFIG_CMA<br />
    [MIGRATE_CMA]     = { MIGRATE_TYPES }, /* Never used */<br />
#endif<br />
#ifdef CONFIG_MEMORY_ISOLATION<br />
    [MIGRATE_ISOLATE]     = { MIGRATE_TYPES }, /* Never used */<br />
#endif<br />
};<br />
</code></pre>
<blockquote><p>该数据结构大体上是自明的 :<br /><br />
每一行对应一个类型的备用搜索域的顺序, 在内核想要分配不可移动页MIGRATE_UNMOVABLE时, 如果对应链表为空, 则遍历fallbacks[MIGRATE_UNMOVABLE], 首先后退到可回收页链表MIGRATE_RECLAIMABLE, 接下来到可移动页链表<code>MIGRATE_MOVABLE</code>, 最后到紧急分配链表MIGRATE_TYPES.</p></blockquote>
<h4>3.3.3 pageblock_order变量</h4>
<p>全局变量和辅助函数尽管页可移动性分组特性总是编译到内核中，但只有在系统中有足够内存可以分配到多个迁移类型对应的链表时，才是有意义的。由于每个迁移链表都应该有适当数量的内存，内核需要定义”适当”的概念. 这是通过两个全局变量pageblock_order和pageblock_nr_pages提供的. 第一个表示内核认为是”大”的一个分配阶, pageblock_nr_pages则表示该分配阶对应的页数。如果体系结构提供了巨型页机制, 则pageblock_order通常定义为巨型页对应的分配阶. 定义在<a href="https://elixir.bootlin.com/linux/v4.7/source/include/linux/pageblock-flags.h#L42" rel="external nofollow noreferrer">include/linux/pageblock-flags.h?v=4.7, line 44</a></p>
<pre class="prettyprint linenums"><code>#ifdef CONFIG_HUGETLB_PAGE

    #ifdef CONFIG_HUGETLB_PAGE_SIZE_VARIABLE

        /* Huge page sizes are variable */<br />
        extern unsigned int pageblock_order;

    #else /* CONFIG_HUGETLB_PAGE_SIZE_VARIABLE */

    /* Huge pages are a constant size */<br />
        #define pageblock_order         HUGETLB_PAGE_ORDER

    #endif /* CONFIG_HUGETLB_PAGE_SIZE_VARIABLE */

#else /* CONFIG_HUGETLB_PAGE */

    /* If huge pages are not used, group by MAX_ORDER_NR_PAGES */<br />
    #define pageblock_order         (MAX_ORDER-1)

#endif /* CONFIG_HUGETLB_PAGE */

#define pageblock_nr_pages      (1UL &lt;&lt; pageblock_order)<br />
</code></pre>
<p>在IA-32体系结构上, 巨型页长度是4MB, 因此每个巨型页由1024个普通页组成, 而HUGETLB_PAGE_ORDER则定义为10. 相比之下, IA-64体系结构允许设置可变的普通和巨型页长度, 因此HUGETLB_PAGE_ORDER的值取决于内核配置.</p>
<p>如果体系结构不支持巨型页, 则将其定义为第二高的分配阶, 即<code>MAX_ORDER - 1</code></p>
<pre class="prettyprint linenums"><code>/* If huge pages are not used, group by MAX_ORDER_NR_PAGES */<br />
#define pageblock_order         (MAX_ORDER-1)

</code></pre>
<p>如果各迁移类型的链表中没有一块较大的连续内存, 那么页面迁移不会提供任何好处, 因此在可用内存太少时内核会关闭该特性. 这是在build_all_zonelists函数中检查的, 该函数用于初始化内存域列表. 如果没有足够的内存可用, 则全局变量<code>page_group_by_mobility_disabled</code>设置为0, 否则设置为1.</p>
<p>内核如何知道给定的分配内存属于何种迁移类型?</p>
<p>我们将在以后讲解, 有关各个内存分配的细节都通过分配掩码指定.</p>
<p>内核提供了两个标志，分别用于表示分配的内存是可移动的(__GFP_MOVABLE)或可回收的(__GFP_RECLAIMABLE).</p>
<h4>3.3.4 gfpflags_to_migratetype函数</h4>
<pre class="prettyprint linenums"><code>/* Convert GFP flags to their corresponding migrate type */<br />
static inline int allocflags_to_migratetype(gfp_t gfp_flags)<br />
{<br />
    WARN_ON((gfp_flags &amp; GFP_MOVABLE_MASK) == GFP_MOVABLE_MASK);

    if (unlikely(page_group_by_mobility_disabled))<br />
        return MIGRATE_UNMOVABLE;

    /* Group based on mobility */<br />
    return (((gfp_flags &amp; __GFP_MOVABLE) != 0) &lt;&lt; 1) |<br />
        ((gfp_flags &amp; __GFP_RECLAIMABLE) != 0);<br />
}<br />
</code></pre>
<p>如果停用了页面迁移特性, 则所有的页都是不可移动的. 否则. 该函数的返回值可以直接用作free_area.free_list的数组索引.</p>
<h4>3.3.5 pageblock_flags变量与其函数接口</h4>
<p>最后要注意, 每个内存域都提供了一个特殊的字段, 可以跟踪包含pageblock_nr_pages个页的内存区的属性. 即zone-&gt;pageblock_flags字段, 当前只有与页可移动性相关的代码使用, 参见<a href="https://elixir.bootlin.com/linux/v4.7/source/include/linux/mmzone.h#L367" rel="external nofollow noreferrer">include/linux/mmzone.h?v=4.7, line 367</a></p>
<pre class="prettyprint linenums"><code>struct zone<br />
{<br />
#ifndef CONFIG_SPARSEMEM<br />
    /*<br />
     * Flags for a pageblock_nr_pages block. See pageblock-flags.h.<br />
     * In SPARSEMEM, this map is stored in struct mem_section<br />
     */<br />
    unsigned long       *pageblock_flags;<br />
#endif /* CONFIG_SPARSEMEM */<br />
};<br />
</code></pre>
<p>在初始化期间, 内核自动确保对内存域中的每个不同的迁移类型分组, 在pageblock_flags中都分配了足够存储NR_PAGEBLOCK_BITS个比特位的空间。当前，表示一个连续内存区的迁移类型需要3个比特位, 参见<a href="https://elixir.bootlin.com/linux/v4.7/source/include/linux/pageblock-flags.h#L28" rel="external nofollow noreferrer">include/linux/pageblock-flags.h?v=4.7, line 28</a></p>
<pre class="prettyprint linenums"><code>/* Bit indices that affect a whole block of pages */<br />
enum pageblock_bits {<br />
    PB_migrate,<br />
    PB_migrate_end = PB_migrate + 3 - 1,<br />
            /* 3 bits required for migrate types */<br />
    PB_migrate_skip,/* If set the block is skipped by compaction */

    /*<br />
     * Assume the bits will always align on a word. If this assumption<br />
     * changes then get/set pageblock needs updating.<br />
     */<br />
    NR_PAGEBLOCK_BITS<br />
};<br />
</code></pre>
<p>内核提供<code>set_pageblock_migratetype</code>负责设置以page为首的一个内存区的迁移类型, 该函数定义在<a href="https://elixir.bootlin.com/linux/v4.7/source/mm/page_alloc.c#L458" rel="external nofollow noreferrer">mm/page_alloc.c?v=4.7, line 458</a>, 如下所示</p>
<pre class="prettyprint linenums"><code>void set_pageblock_migratetype(struct page *page, int migratetype)<br />
{<br />
    if (unlikely(page_group_by_mobility_disabled &amp;&amp;<br />
             migratetype &lt; MIGRATE_PCPTYPES))<br />
        migratetype = MIGRATE_UNMOVABLE;

    set_pageblock_flags_group(page, (unsigned long)migratetype,<br />
                    PB_migrate, PB_migrate_end);<br />
}<br />
</code></pre>
<p>migratetype参数可以通过上文介绍的gfpflags_to_migratetype辅助函数构建. 请注意很重要的一点, 页的迁移类型是预先分配好的, 对应的比特位总是可用, 与页是否由伙伴系统管理无关. 在释放内存时，页必须返回到正确的迁移链表。这之所以可行，是因为能够从get_pageblock_migratetype获得所需的信息. 参见<a href="https://elixir.bootlin.com/linux/v4.7/source/include/linux/mmzone.h#L84" rel="external nofollow noreferrer">include/linux/mmzone.h?v=4.7, line 84</a></p>
<pre class="prettyprint linenums"><code>#define get_pageblock_migratetype(page)                                 \<br />
        get_pfnblock_flags_mask(page, page_to_pfn(page),                \<br />
                        PB_migrate_end, MIGRATETYPE_MASK)<br />
</code></pre>
<p>最后请注意, 在各个迁移链表之间, 当前的页面分配状态可以从<code>/proc/pagetypeinfo</code>获得.</p>
<h4>初始化基于可移动性的分组</h4>
<p>在内存子系统初始化期间, memmap_init_zone负责处理内存域的page实例. 该函数定义在<a href="http://lxr.free-electrons.com/source/mm/page_alloc.c?v=4.7#L5139" rel="external nofollow noreferrer">mm/page_alloc.c?v=4.7, line 5139</a>, 该函数完成了一些不怎么有趣的标准初始化工作，但其中有一件是实质性的，即所有的页最初都标记为可移动的. 参见<a href="https://elixir.bootlin.com/linux/v4.7/source/mm/page_alloc.c#L5224" rel="external nofollow noreferrer">mm/page_alloc.c?v=4.7, line 5224</a></p>
<pre class="prettyprint linenums"><code>/*<br />
 * Initially all pages are reserved - free ones are freed<br />
 * up by free_all_bootmem() once the early boot process is<br />
 * done. Non-atomic initialization, single-pass.<br />
 */<br />
void __meminit memmap_init_zone(unsigned long size, int nid, unsigned long zone,<br />
        unsigned long start_pfn, enum memmap_context context)<br />
{<br />
    /*  ......  */

    for (pfn = start_pfn; pfn &lt; end_pfn; pfn++) {<br />
        /*  ......  */<br />
not_early:<br />
        if (!(pfn &amp; (pageblock_nr_pages - 1))) {<br />
            struct page *page = pfn_to_page(pfn);

            __init_single_page(page, pfn, zone, nid);<br />
            set_pageblock_migratetype(page, MIGRATE_MOVABLE);<br />
        } else {<br />
            __init_single_pfn(pfn, zone, nid);<br />
        }<br />
    }<br />
}<br />
</code></pre>
<p>在分配内存时, 如果必须”盗取”不同于预定迁移类型的内存区, 内核在策略上倾向于”盗取”更大的内存区. 由于所有页最初都是可移动的, 那么在内核分配不可移动的内存区时, 则必须”盗取”.</p>
<p>实际上, 在启动期间分配可移动内存区的情况较少, 那么分配器有很高的几率分配长度最大的内存区, 并将其从可移动列表转换到不可移动列表. 由于分配的内存区长度是最大的, 因此不会向可移动内存中引入碎片.</p>
<p>总而言之, 这种做法避免了启动期间内核分配的内存(经常在系统的整个运行时间都不释放)散布到物理内存各处, 从而使其他类型的内存分配免受碎片的干扰，这也是页可移动性分组框架的最重要的目标之一.</p>
<h2>4 分配器API</h2>
<h3>4.1 分配内存的接口</h3>
<p>就伙伴系统的接口而言, NUMA或UMA体系结构是没有差别的, 二者的调用语法都是相同的.</p>
<p>所有函数的一个共同点是 : 只能分配2的整数幂个页.</p>
<p>因此，接口中不像C标准库的malloc函数或bootmem和memblock分配器那样指定了所需内存大小作为参数. 相反, 必须指定的是分配阶, 伙伴系统将在内存中分配2^0 rder页. 内核中细粒度的分配只能借助于slab分配器(或者slub、slob分配器), 后者基于伙伴系统</p>
<table>
<thead>
<tr>
<th>内存分配函数</th>
<th>功能</th>
<th>定义</th>
</tr>
</thead>
<tbody>
<tr>
<td>alloc_pages(mask, order)</td>
<td>分配2^0页并返回一个struct page的实例，表示分配的内存块的起始页</td>
<td><a href="https://elixir.bootlin.com/linux/v4.7/source/include/linux/gfp.h#L466" rel="external nofollow noreferrer">NUMA-include/linux/gfp.h, line 466</a> <br> <a href="https://elixir.bootlin.com/linux/v4.7/source/include/linux/gfp.h#L476" rel="external nofollow noreferrer">UMA-include/linux/gfp.h?v=4.7, line 476</a></td>
</tr>
<tr>
<td>alloc_page(mask)</td>
<td>是前者在order = 0情况下的简化形式，只分配一页</td>
<td><a href="https://elixir.bootlin.com/linux/v4.7/source/include/linux/gfp.h#L483" rel="external nofollow noreferrer">include/linux/gfp.h?v=4.7, line 483</a></td>
</tr>
<tr>
<td>get_zeroed_page(mask)</td>
<td>分配一页并返回一个page实例，页对应的内存填充0（所有其他函数，分配之后页的内容是未定义的）</td>
<td><a href="https://elixir.bootlin.com/linux/v4.7/source/mm/page_alloc.c#L3900" rel="external nofollow noreferrer">mm/page_alloc.c?v=4.7, line 3900</a></td>
</tr>
<tr>
<td><a href="http://lxr.free-electrons.com/source/mm/page_alloc.c?v=4.7#L3883" rel="external nofollow noreferrer">__get_free_pages(mask, order)</a> <br>  <a href="http://lxr.free-electrons.com/source/include/linux/gfp.h?v=4.7#L500" rel="external nofollow noreferrer">__get_free_page(mask)</a></td>
<td>工作方式与上述函数相同，但返回分配内存块的虚拟地址，而不是page实例</td>
<td></td>
</tr>
<tr>
<td>get_dma_pages(gfp_mask, order)</td>
<td>用来获得适用于DMA的页.</td>
<td><a href="https://elixir.bootlin.com/linux/v4.7/source/include/linux/gfp.h#L503" rel="external nofollow noreferrer">include/linux/gfp.h?v=4.7, line 503</a></td>
</tr>
</tbody>
</table>
<p>在空闲内存无法满足请求以至于分配失败的情况下，所有上述函数都返回空指针(比如alloc_pages和alloc_page)或者0(比如get_zeroed_page、__get_free_pages和__get_free_page).</p>
<p>因此内核在各次分配之后都必须检查返回的结果. 这种惯例与设计得很好的用户层应用程序没什么不同, 但在内核中忽略检查会导致严重得多的故障</p>
<p>内核除了伙伴系统函数之外, 还提供了其他内存管理函数. 它们以伙伴系统为基础, 但并不属于伙伴分配器自身. 这些函数包括vmalloc和vmalloc_32, 使用页表将不连续的内存映射到内核地址空间中, 使之看上去是连续的.</p>
<p>还有一组kmalloc类型的函数, 用于分配小于一整页的内存区. 其实现.</p>
<p>释放函数</p>
<p>有4个函数用于释放不再使用的页，与所述函数稍有不同</p>
<table>
<thead>
<tr>
<th>内存释放函数</th>
<th>描述</th>
</tr>
</thead>
<tbody>
<tr>
<td><a href="https://elixir.bootlin.com/linux/v4.7/source/include/linux/gfp.h#L520" rel="external nofollow noreferrer">free_page(struct page )</a><br> <a href="http://lxr.free-electrons.com/source/mm/page_alloc.c?v=4.7#L3918" rel="external nofollow noreferrer">free_pages(struct page , order)</a></td>
<td>用于将一个或2order页返回给内存管理子系统。内存区的起始地址由指向该内存区的第一个page实例的指针表示</td>
</tr>
<tr>
<td>__free_page(addr)<br>__free_pages(addr, order)</td>
<td>类似于前两个函数，但在表示需要释放的内存区时，使用了虚拟内存地址而不是page实例</td>
</tr>
</tbody>
</table>
<h3>4.2 分配掩码(gfp_mask标志)</h3>
<h4>4.2.1 分配掩码</h4>
<p>前述所有函数中强制使用的mask参数，到底是什么语义?</p>
<p>我们知道Linux将内存划分为内存域. 内核提供了所谓的内存域修饰符(zone modifier)(在掩码的最低4个比特位定义), 来指定从哪个内存域分配所需的页.</p>
<p>内核使用宏的方式定义了这些掩码, 一个掩码的定义被划分为3个部分进行定义, 我们会逐步展开来讲解, 参见<a href="https://elixir.bootlin.com/linux/v4.7/source/include/linux/gfp.h#L12" rel="external nofollow noreferrer">include/linux/gfp.h?v=4.7, line 12~374</a>, 共计26个掩码信息, 因此后面__GFP_BITS_SHIFT = 26.</p>
<h4>4.2.2 掩码分类</h4>
<p>Linux中这些掩码标志gfp_mask分为3种类型 :</p>
<table>
<thead>
<tr>
<th>类型</th>
<th>描述</th>
</tr>
</thead>
<tbody>
<tr>
<td>区描述都符</td>
<td>内核把物理内存分为多个区, 每个区用于不同的目的, 区描述符指明到底从这些区中的哪一区进行分配</td>
</tr>
<tr>
<td>行为修饰符</td>
<td>表示内核应该如何分配所需的内存. 在某些特定情况下, 只能使用某些特定的方法分配内存</td>
</tr>
<tr>
<td>类型标志</td>
<td>组合了行为修饰符和区描述符, 将这些可能用到的组合归纳为不同类型</td>
</tr>
</tbody>
</table>
<h4>4.2.3 内核中掩码的定义</h4>
<p><strong>内核中的定义方式</strong></p>
<pre class="prettyprint linenums"><code>//  http://lxr.free-electrons.com/source/include/linux/gfp.h?v=4.7

/*  line 12 ~ line 44  第一部分<br />
 *  定义可掩码所在位的信息, 每个掩码对应一位为1<br />
 *  定义形式为  #define  ___GFP_XXX      0x01u<br />
 */<br />
/* Plain integer GFP bitmasks. Do not use this directly. */<br />
#define ___GFP_DMA              0x01u<br />
#define ___GFP_HIGHMEM          0x02u<br />
#define ___GFP_DMA32            0x04u<br />
#define ___GFP_MOVABLE          0x08u<br />
/*  ......  */

/*  line 46 ~ line 192  第二部分<br />
 *  定义掩码和MASK信息, 第二部分的某些宏可能是第一部分一个或者几个的组合<br />
 *  定义形式为  #define  __GFP_XXX        ((__force gfp_t)___GFP_XXX)<br />
 */<br />
#define __GFP_DMA       ((__force gfp_t)___GFP_DMA)<br />
#define __GFP_HIGHMEM   ((__force gfp_t)___GFP_HIGHMEM)<br />
#define __GFP_DMA32     ((__force gfp_t)___GFP_DMA32)<br />
#define __GFP_MOVABLE   ((__force gfp_t)___GFP_MOVABLE)  /* ZONE_MOVABLE allowed */<br />
#define GFP_ZONEMASK    (__GFP_DMA|__GFP_HIGHMEM|__GFP_DMA32|__GFP_MOVABLE)

/*  line 194 ~ line 260  第三部分<br />
 *  定义掩码<br />
 *  定义形式为  #define  GFP_XXX      __GFP_XXX<br />
 */<br />
#define GFP_DMA         __GFP_DMA<br />
#define GFP_DMA32       __GFP_DMA32<br />
</code></pre>
<p>其中GFP缩写的意思为获取空闲页(get free page), __GFP_MOVABLE不表示物理内存域, 但通知内核应在特殊的虚拟内存域ZONE_MOVABLE进行相应的分配.</p>
<p><strong>定义掩码位</strong></p>
<p>我们首先来看第一部分, 内核源代码中定义在<a href="https://elixir.bootlin.com/linux/v4.7/source/include/linux/gfp.h#L17" rel="external nofollow noreferrer">include/linux/gfp.h?v=4.7, line 18 ~ line 44</a>, 共计26个掩码信息.</p>
<pre class="prettyprint linenums"><code>/* Plain integer GFP bitmasks. Do not use this directly. */<br />
//  区域修饰符<br />
#define ___GFP_DMA              0x01u<br />
#define ___GFP_HIGHMEM          0x02u<br />
#define ___GFP_DMA32            0x04u

//  行为修饰符<br />
#define ___GFP_MOVABLE          0x08u       /* 页是可移动的 */<br />
#define ___GFP_RECLAIMABLE      0x10u       /* 页是可回收的 */<br />
#define ___GFP_HIGH             0x20u       /* 应该访问紧急分配池？ */<br />
#define ___GFP_IO               0x40u       /* 可以启动物理IO？ */<br />
#define ___GFP_FS               0x80u       /* 可以调用底层文件系统？ */<br />
#define ___GFP_COLD             0x100u     /* 需要非缓存的冷页 */<br />
#define ___GFP_NOWARN           0x200u     /* 禁止分配失败警告 */<br />
#define ___GFP_REPEAT           0x400u     /* 重试分配，可能失败 */<br />
#define ___GFP_NOFAIL           0x800u     /* 一直重试，不会失败 */<br />
#define ___GFP_NORETRY          0x1000u   /* 不重试，可能失败 */<br />
#define ___GFP_MEMALLOC         0x2000u     /* 使用紧急分配链表 */<br />
#define ___GFP_COMP             0x4000u   /* 增加复合页元数据 */<br />
#define ___GFP_ZERO             0x8000u   /* 成功则返回填充字节0的页 */<br />
//  类型修饰符<br />
#define ___GFP_NOMEMALLOC       0x10000u     /* 不使用紧急分配链表 */<br />
#define ___GFP_HARDWALL         0x20000u     /* 只允许在进程允许运行的CPU所关联的结点分配内存 */<br />
#define ___GFP_THISNODE         0x40000u     /* 没有备用结点，没有策略 */<br />
#define ___GFP_ATOMIC           0x80000u    /* 用于原子分配，在任何情况下都不能中断  */<br />
#define ___GFP_ACCOUNT          0x100000u<br />
#define ___GFP_NOTRACK          0x200000u<br />
#define ___GFP_DIRECT_RECLAIM   0x400000u<br />
#define ___GFP_OTHER_NODE       0x800000u<br />
#define ___GFP_WRITE            0x1000000u<br />
#define ___GFP_KSWAPD_RECLAIM   0x2000000u<br />
</code></pre>
<p><strong>定义掩码</strong></p>
<p>然后第二部分, 相对而言每一个宏又被重新定义如下, 参见<a href="https://elixir.bootlin.com/linux/v4.7/source/include/linux/gfp.h#L46" rel="external nofollow noreferrer">include/linux/gfp.h?v=4.7, line 46 ~ line 192</a></p>
<pre class="prettyprint linenums"><code>/*<br />
* Physical address zone modifiers (see linux/mmzone.h - low four bits)<br />
*<br />
* Do not put any conditional on these. If necessary modify the definitions<br />
* without the underscores and use them consistently. The definitions here may<br />
* be used in bit comparisons.<br />
* 定义区描述符<br />
*/<br />
#define __GFP_DMA       ((__force gfp_t)___GFP_DMA)<br />
#define __GFP_HIGHMEM   ((__force gfp_t)___GFP_HIGHMEM)<br />
#define __GFP_DMA32     ((__force gfp_t)___GFP_DMA32)<br />
#define __GFP_MOVABLE   ((__force gfp_t)___GFP_MOVABLE)  /* ZONE_MOVABLE allowed */<br />
#define GFP_ZONEMASK    (__GFP_DMA|__GFP_HIGHMEM|__GFP_DMA32|__GFP_MOVABLE)

/*<br />
* Page mobility and placement hints<br />
*<br />
* These flags provide hints about how mobile the page is. Pages with similar<br />
* mobility are placed within the same pageblocks to minimise problems due<br />
* to external fragmentation.<br />
*<br />
* __GFP_MOVABLE (also a zone modifier) indicates that the page can be<br />
*   moved by page migration during memory compaction or can be reclaimed.<br />
*<br />
* __GFP_RECLAIMABLE is used for slab allocations that specify<br />
*   SLAB_RECLAIM_ACCOUNT and whose pages can be freed via shrinkers.<br />
*<br />
* __GFP_WRITE indicates the caller intends to dirty the page. Where possible,<br />
*   these pages will be spread between local zones to avoid all the dirty<br />
*   pages being in one zone (fair zone allocation policy).<br />
*<br />
* __GFP_HARDWALL enforces the cpuset memory allocation policy.<br />
*<br />
* __GFP_THISNODE forces the allocation to be satisified from the requested<br />
*   node with no fallbacks or placement policy enforcements.<br />
*<br />
* __GFP_ACCOUNT causes the allocation to be accounted to kmemcg (only relevant<br />
*   to kmem allocations).<br />
*/<br />
#define __GFP_RECLAIMABLE ((__force gfp_t)___GFP_RECLAIMABLE)<br />
#define __GFP_WRITE     ((__force gfp_t)___GFP_WRITE)<br />
#define __GFP_HARDWALL   ((__force gfp_t)___GFP_HARDWALL)<br />
#define __GFP_THISNODE  ((__force gfp_t)___GFP_THISNODE)<br />
#define __GFP_ACCOUNT   ((__force gfp_t)___GFP_ACCOUNT)

/*<br />
* Watermark modifiers -- controls access to emergency reserves<br />
*<br />
* __GFP_HIGH indicates that the caller is high-priority and that granting<br />
*   the request is necessary before the system can make forward progress.<br />
*   For example, creating an IO context to clean pages.<br />
*<br />
* __GFP_ATOMIC indicates that the caller cannot reclaim or sleep and is<br />
*   high priority. Users are typically interrupt handlers. This may be<br />
*   used in conjunction with __GFP_HIGH<br />
 *<br />
 * __GFP_MEMALLOC allows access to all memory. This should only be used when<br />
 *   the caller guarantees the allocation will allow more memory to be freed<br />
 *   very shortly e.g. process exiting or swapping. Users either should<br />
 *   be the MM or co-ordinating closely with the VM (e.g. swap over NFS).<br />
 *<br />
 * __GFP_NOMEMALLOC is used to explicitly forbid access to emergency reserves.<br />
 *   This takes precedence over the __GFP_MEMALLOC flag if both are set.<br />
 */<br />
#define __GFP_ATOMIC    ((__force gfp_t)___GFP_ATOMIC)<br />
#define __GFP_HIGH      ((__force gfp_t)___GFP_HIGH)<br />
#define __GFP_MEMALLOC  ((__force gfp_t)___GFP_MEMALLOC)<br />
#define __GFP_NOMEMALLOC ((__force gfp_t)___GFP_NOMEMALLOC)

/*<br />
 * Reclaim modifiers<br />
 *<br />
 * __GFP_IO can start physical IO.<br />
 *<br />
 * __GFP_FS can call down to the low-level FS. Clearing the flag avoids the<br />
 *   allocator recursing into the filesystem which might already be holding<br />
 *   locks.<br />
 *<br />
 * __GFP_DIRECT_RECLAIM indicates that the caller may enter direct reclaim.<br />
 *   This flag can be cleared to avoid unnecessary delays when a fallback<br />
 *   option is available.<br />
 *<br />
 * __GFP_KSWAPD_RECLAIM indicates that the caller wants to wake kswapd when<br />
 *   the low watermark is reached and have it reclaim pages until the high<br />
 *   watermark is reached. A caller may wish to clear this flag when fallback<br />
 *   options are available and the reclaim is likely to disrupt the system. The<br />
 *   canonical example is THP allocation where a fallback is cheap but<br />
 *   reclaim/compaction may cause indirect stalls.<br />
 *<br />
 * __GFP_RECLAIM is shorthand to allow/forbid both direct and kswapd reclaim.<br />
 *<br />
 * __GFP_REPEAT: Try hard to allocate the memory, but the allocation attempt<br />
 *   _might_ fail.  This depends upon the particular VM implementation.<br />
 *<br />
 * __GFP_NOFAIL: The VM implementation _must_ retry infinitely: the caller<br />
 *   cannot handle allocation failures. New users should be evaluated carefully<br />
 *   (and the flag should be used only when there is no reasonable failure<br />
 *   policy) but it is definitely preferable to use the flag rather than<br />
 *   opencode endless loop around allocator.<br />
 *<br />
 * __GFP_NORETRY: The VM implementation must not retry indefinitely and will<br />
 *   return NULL when direct reclaim and memory compaction have failed to allow<br />
 *   the allocation to succeed.  The OOM killer is not called with the current<br />
 *   implementation.<br />
 */<br />
#define __GFP_IO        ((__force gfp_t)___GFP_IO)<br />
#define __GFP_FS        ((__force gfp_t)___GFP_FS)<br />
#define __GFP_DIRECT_RECLAIM    ((__force gfp_t)___GFP_DIRECT_RECLAIM) /* Caller can reclaim */<br />
#define __GFP_KSWAPD_RECLAIM    ((__force gfp_t)___GFP_KSWAPD_RECLAIM) /* kswapd can wake */<br />
#define __GFP_RECLAIM ((__force gfp_t)(___GFP_DIRECT_RECLAIM|___GFP_KSWAPD_RECLAIM))<br />
#define __GFP_REPEAT    ((__force gfp_t)___GFP_REPEAT)<br />
#define __GFP_NOFAIL    ((__force gfp_t)___GFP_NOFAIL)<br />
#define __GFP_NORETRY   ((__force gfp_t)___GFP_NORETRY)

/*<br />
 * Action modifiers<br />
 *<br />
 * __GFP_COLD indicates that the caller does not expect to be used in the near<br />
 *   future. Where possible, a cache-cold page will be returned.<br />
 *<br />
 * __GFP_NOWARN suppresses allocation failure reports.<br />
 *<br />
 * __GFP_COMP address compound page metadata.<br />
 *<br />
 * __GFP_ZERO returns a zeroed page on success.<br />
 *<br />
 * __GFP_NOTRACK avoids tracking with kmemcheck.<br />
 *<br />
 * __GFP_NOTRACK_FALSE_POSITIVE is an alias of __GFP_NOTRACK. It's a means of<br />
 *   distinguishing in the source between false positives and allocations that<br />
 *   cannot be supported (e.g. page tables).<br />
 *<br />
 * __GFP_OTHER_NODE is for allocations that are on a remote node but that<br />
 *   should not be accounted for as a remote allocation in vmstat. A<br />
 *   typical user would be khugepaged collapsing a huge page on a remote<br />
 *   node.<br />
 */<br />
#define __GFP_COLD      ((__force gfp_t)___GFP_COLD)<br />
#define __GFP_NOWARN    ((__force gfp_t)___GFP_NOWARN)<br />
#define __GFP_COMP      ((__force gfp_t)___GFP_COMP)<br />
#define __GFP_ZERO      ((__force gfp_t)___GFP_ZERO)<br />
#define __GFP_NOTRACK   ((__force gfp_t)___GFP_NOTRACK)<br />
#define __GFP_NOTRACK_FALSE_POSITIVE (__GFP_NOTRACK)<br />
#define __GFP_OTHER_NODE ((__force gfp_t)___GFP_OTHER_NODE)

/* Room for N __GFP_FOO bits */<br />
#define __GFP_BITS_SHIFT 26<br />
#define __GFP_BITS_MASK ((__force gfp_t)((1 &lt;&lt; __GFP_BITS_SHIFT) - 1))<br />
</code></pre>
<p>给出的常数，其中一些很少使用，因此我不会讨论。其中最重要的一些常数语义如下所示</p>
<p>其中在开始的位置定义了对应的区修饰符, 定义在<a href="http://lxr.free-electrons.com/source/include/linux/gfp.h?v=4.7#L46" rel="external nofollow noreferrer">include/linux/gfp.h?v=4.7, line 46 ~ line 57</a></p>
<table>
<thead>
<tr>
<th>区修饰符标志</th>
<th>描述</th>
</tr>
</thead>
<tbody>
<tr>
<td>__GFP_DMA</td>
<td>从ZONE_DMA中分配内存</td>
</tr>
<tr>
<td>__GFP_HIGHMEM</td>
<td>从ZONE_HIGHMEM活ZONE_NORMAL中分配内存</td>
</tr>
<tr>
<td>__GFP_DMA32</td>
<td>从ZONE_DMA32中分配内存</td>
</tr>
<tr>
<td>__GFP_MOVABLE</td>
<td>从__GFP_MOVABLE中分配内存</td>
</tr>
</tbody>
</table>
<p>其次还定义了我们程序和函数中所需要的掩码MASK的信息, 由于其中__GFP_DMA, __GFP_DMA32, __GFP_HIGHMEM, __GFP_MOVABLE是在内存中分别有对应的内存域信息, 因此我们定义了内存域的掩码GFP_ZONEMASK, 参见<a href="http://lxr.free-electrons.com/source/include/linux/gfp.h?v=4.7#L57" rel="external nofollow noreferrer">include/linux/gfp.h?v=4.7, line 57</a></p>
<pre class="prettyprint linenums"><code>#define GFP_ZONEMASK    (__GFP_DMA|__GFP_HIGHMEM|__GFP_DMA32|__GFP_MOVABLE)<br />
</code></pre>
<p>接着内核定义了行为修饰符</p>
<p>/* __GFP_WAIT表示分配内存的请求可以中断。也就是说，调度器在该请求期间可随意选择另一个过程执行，或者该请求可以被另一个更重要的事件中断. 分配器还可以在返回内存之前, 在队列上等待一个事件(相关进程会进入睡眠状态).</p>
<blockquote><p>虽然名字相似，但__GFP_HIGH与__GFP_HIGHMEM毫无关系，请不要弄混这两者\</p></blockquote>
<table>
<thead>
<tr>
<th>行为修饰符</th>
<th>描述</th>
</tr>
</thead>
<tbody>
<tr>
<td>__GFP_RECLAIMABLE <br> __GFP_MOVABLE</td>
<td>是页迁移机制所需的标志. 顾名思义，它们分别将分配的内存标记为可回收的或可移动的。这影响从空闲列表的哪个子表获取内存</td>
</tr>
<tr>
<td>__GFP_WRITE</td>
<td></td>
</tr>
<tr>
<td>__GFP_HARDWALL</td>
<td>只在NUMA系统上有意义. 它限制只在分配到当前进程的各个CPU所关联的结点分配内存。如果进程允许在所有CPU上运行（默认情况），该标志是无意义的。只有进程可以运行的CPU受限时，该标志才有效果</td>
</tr>
<tr>
<td>__GFP_THISNODE</td>
<td>也只在NUMA系统上有意义。如果设置该比特位，则内存分配失败的情况下不允许使用其他结点作为备用，需要保证在当前结点或者明确指定的结点上成功分配内存</td>
</tr>
<tr>
<td>__GFP_ACCOUNT</td>
<td></td>
</tr>
<tr>
<td>__GFP_ATOMIC</td>
<td></td>
</tr>
<tr>
<td>__GFP_HIGH</td>
<td>如果请求非常重要, 则设置__GFP_HIGH，即内核急切地需要内存时。在分配内存失败可能给内核带来严重后果时(比如威胁到系统稳定性或系统崩溃), 总是会使用该标志</td>
</tr>
<tr>
<td>__GFP_MEMALLOC</td>
<td></td>
</tr>
<tr>
<td>__GFP_NOMEMALLOC</td>
<td></td>
</tr>
<tr>
<td>__GFP_IO</td>
<td>说明在查找空闲内存期间内核可以进行I/O操作. 实际上, 这意味着如果内核在内存分配期间换出页, 那么仅当设置该标志时, 才能将选择的页写入硬盘</td>
</tr>
<tr>
<td>__GFP_FS</td>
<td>允许内核执行VFS操作. 在与VFS层有联系的内核子系统中必须禁用, 因为这可能引起循环递归调用.</td>
</tr>
<tr>
<td>__GFP_DIRECT_RECLAIM</td>
<td></td>
</tr>
<tr>
<td>__GFP_KSWAPD_RECLAIM</td>
<td></td>
</tr>
<tr>
<td>__GFP_RECLAIM</td>
<td></td>
</tr>
<tr>
<td>__GFP_REPEAT</td>
<td>在分配失败后自动重试，但在尝试若干次之后会停止</td>
</tr>
<tr>
<td>__GFP_NOFAIL</td>
<td>在分配失败后一直重试，直至成功</td>
</tr>
<tr>
<td>__GFP_NORETRY</td>
<td>在分配失败后不重试，因此可能分配失败</td>
</tr>
<tr>
<td>__GFP_COLD</td>
<td>如果需要分配不在CPU高速缓存中的“冷”页时，则设置__GFP_COLD</td>
</tr>
<tr>
<td>__GFP_NOWARN</td>
<td>在分配失败时禁止内核故障警告。在极少数场合该标志有用</td>
</tr>
<tr>
<td>__GFP_COMP</td>
<td>添加混合页元素, 在hugetlb的代码内部使用</td>
</tr>
<tr>
<td>__GFP_ZERO</td>
<td>在分配成功时，将返回填充字节0的页</td>
</tr>
<tr>
<td>__GFP_NOTRACK</td>
<td></td>
</tr>
<tr>
<td>__GFP_NOTRACK_FALSE_POSITIVE <br> __GFP_NOTRACK</td>
<td></td>
</tr>
<tr>
<td>__GFP_OTHER_NODE</td>
<td></td>
</tr>
</tbody>
</table>
<p>那自然还有__GFP_BITS_SHIFT来表示我们所有的掩码位, 由于我们共计26个掩码位</p>
<pre class="prettyprint linenums"><code>/* Room for N __GFP_FOO bits */<br />
#define __GFP_BITS_SHIFT 26<br />
#define __GFP_BITS_MASK ((__force gfp_t)((1 &lt;&lt; __GFP_BITS_SHIFT) - 1))<br />
</code></pre>
<p>可以同时指定这些分配标志, 例如</p>
<pre class="prettyprint linenums"><code>ptr = kmalloc(size, __GFP_IO | __GFP_FS);<br />
</code></pre>
<p>说明页分配器(最终会调用alloc_page)在分配时可以执行I/O, 在必要时还可以执行文件系统操作. 这就让内核有很大的自由度, 以便它尽可能找到空闲的内存来满足分配请求. 大多数分配器都会执行这些修饰符, 但一般不是这样直接指定, 而是将这些行为描述符标志进行分组, 即类型标志</p>
<p><strong>掩码分组</strong></p>
<p>最后来看第三部分, 由于这些标志几乎总是组合使用，内核作了一些分组，包含了用于各种标准情形的适当的标志. 称之为类型标志, 定义在<a href="http://lxr.free-electrons.com/source/include/linux/gfp.h?v=4.7#L245" rel="external nofollow noreferrer">include/linux/gfp.h?v=4.7, lien 194 ~ line 258</a></p>
<p>类型标志指定所需的行为和区描述符以安城特殊类型的处理, 正因为这一点, 内核总是趋于使用正确的类型标志, 而不是一味地指定它可能用到的多种描述符. 这么做既简单又不容易出错误.</p>
<p>如果有可能的话, 在内存管理子系统之外, 总是把下列分组之一用于内存分配. 在内核源代码中, 双下划线通常用于内部数据和定义. 而这些预定义的分组名没有双下划线前缀, 点从侧面验证了上述说法.</p>
<pre class="prettyprint linenums"><code>#define GFP_ATOMIC      (__GFP_HIGH|__GFP_ATOMIC|__GFP_KSWAPD_RECLAIM)<br />
#define GFP_KERNEL      (__GFP_RECLAIM | __GFP_IO | __GFP_FS)<br />
#define GFP_KERNEL_ACCOUNT (GFP_KERNEL | __GFP_ACCOUNT)<br />
#define GFP_NOWAIT      (__GFP_KSWAPD_RECLAIM)<br />
#define GFP_NOIO        (__GFP_RECLAIM)<br />
#define GFP_NOFS        (__GFP_RECLAIM | __GFP_IO)<br />
#define GFP_TEMPORARY   (__GFP_RECLAIM | __GFP_IO | __GFP_FS | \<br />
                         __GFP_RECLAIMABLE)<br />
#define GFP_USER        (__GFP_RECLAIM | __GFP_IO | __GFP_FS | __GFP_HARDWALL)<br />
#define GFP_DMA         __GFP_DMA<br />
#define GFP_DMA32       __GFP_DMA32<br />
#define GFP_HIGHUSER    (GFP_USER | __GFP_HIGHMEM)<br />
#define GFP_HIGHUSER_MOVABLE    (GFP_HIGHUSER | __GFP_MOVABLE)<br />
#define GFP_TRANSHUGE   ((GFP_HIGHUSER_MOVABLE | __GFP_COMP | \<br />
                         __GFP_NOMEMALLOC | __GFP_NORETRY | __GFP_NOWARN) &amp; \<br />
                         ~__GFP_RECLAIM)

/* Convert GFP flags to their corresponding migrate type */<br />
#define GFP_MOVABLE_MASK (__GFP_RECLAIMABLE|__GFP_MOVABLE)<br />
#define GFP_MOVABLE_SHIFT 3

</code></pre>
<table>
<thead>
<tr>
<th>掩码组</th>
<th>描述</th>
</tr>
</thead>
<tbody>
<tr>
<td>GFP_ATOMIC</td>
<td>用于原子分配，在任何情况下都不能中断, 可能使用紧急分配链表中的内存, 这个标志用在中断处理程序, 下半部, 持有自旋锁以及其他不能睡眠的地方</td>
</tr>
<tr>
<td>GFP_KERNEL</td>
<td>这是一种常规的分配方式, 可能会阻塞. 这个标志在睡眠安全时用在进程的长下文代码中. 为了获取调用者所需的内存, 内核会尽力而为. 这个标志应该是首选标志</td>
</tr>
<tr>
<td>GFP_KERNEL_ACCOUNT</td>
<td></td>
</tr>
<tr>
<td>GFP_NOWAIT</td>
<td>与GFP_ATOMIC类似, 不同之处在于, 调用不会退给紧急内存池, 这就增加了内存分配失败的可能性</td>
</tr>
<tr>
<td>GFP_NOIO</td>
<td>这种分配可以阻塞, 但不会启动磁盘I/O, 这个标志在不能引发更多的磁盘I/O时阻塞I/O代码, 这可能导致令人不愉快的递归</td>
</tr>
<tr>
<td>GFP_NOFS</td>
<td>这种分配在必要时可以阻塞, 但是也可能启动磁盘, 但是不会启动文件系统操作, 这个标志在你不鞥在启动另一个文件系统操作时, 用在文件系统部分的代码中</td>
</tr>
<tr>
<td>GFP_TEMPORARY</td>
<td></td>
</tr>
<tr>
<td>GFP_USER</td>
<td>这是一种常规的分配方式, 可能会阻塞. 这个标志用于为用户空间进程分配内存时使用</td>
</tr>
<tr>
<td>GFP_DMA</td>
<td></td>
</tr>
<tr>
<td>GFP_DMA32</td>
<td>用于分配适用于DMA的内存, 当前是__GFP_DMA的同义词, GFP_DMA32也是__GFP_GMA32的同义词</td>
</tr>
<tr>
<td>GFP_HIGHUSER</td>
<td>是GFP_USER的一个扩展, 也用于用户空间. 它允许分配无法直接映射的高端内存. 使用高端内存页是没有坏处的，因为用户过程的地址空间总是通过非线性页表组织的</td>
</tr>
<tr>
<td>GFP_HIGHUSER_MOVABLE</td>
<td>用途类似于GFP_HIGHUSER，但分配将从虚拟内存域ZONE_MOVABLE进行</td>
</tr>
<tr>
<td>GFP_TRANSHUGE</td>
<td></td>
</tr>
</tbody>
</table>
<ul><li>其中GFP_NOIO和GFP_NOFS, 分别明确禁止I/O操作和访问VFS层, 但同时设置了__GFP_RECLAIM，因此可以被回收</li>
<li>而GFP_KERNEL和GFP_USER. 分别是内核和用户分配的默认设置。二者的失败不会立即威胁系统稳定性, GFP_KERNEL绝对是内核源代码中最常使用的标志 |</li></ul>
<p>最后内核设置了碎片管理的可移动依据组织页的MASK信息GFP_MOVABLE_MASK, 参见<a href="http://lxr.free-electrons.com/source/include/linux/gfp.h?v=4.7#L262" rel="external nofollow noreferrer">include/linux/gfp.h?v=4.7, line 262</a></p>
<pre class="prettyprint linenums"><code>/* Convert GFP flags to their corresponding migrate type */<br />
#define GFP_MOVABLE_MASK (__GFP_RECLAIMABLE|__GFP_MOVABLE)<br />
#define GFP_MOVABLE_SHIFT 3<br />
</code></pre>
<p>在你编写的绝大多数代码中, 用么用到的是GFP_KERNEL, 要么是GFP_ATOMIC, 当然各个类型标志也均有其应用场景</p>
<table>
<thead>
<tr>
<th>情形</th>
<th>相应标志</th>
</tr>
</thead>
<tbody>
<tr>
<td>进程上下文, 可以睡眠</td>
<td>使用GFP_KERNEL</td>
</tr>
<tr>
<td>进程上下文, 不可以睡眠</td>
<td>使用GFP_KERNEL, 在你睡眠之前或之后以GFP_KERNEL执行内存分配</td>
</tr>
<tr>
<td>中断处理程序</td>
<td>使用GFP_ATMOIC</td>
</tr>
<tr>
<td>软中断</td>
<td>使用GFP_ATMOIC</td>
</tr>
<tr>
<td>tasklet</td>
<td>使用GFP_ATMOIC</td>
</tr>
<tr>
<td>需要用于DMA的内存, 可以睡眠</td>
<td>使用(GFP_DMA GFP_KERNEL)</td>
</tr>
<tr>
<td>需要用于DMA的内存, 不可以睡眠</td>
<td>使用(GFP_DMA GFP_ATOMIC), 或在你睡眠之前执行内存分配</td>
</tr>
</tbody>
</table>
<h4>4.2.5 总结</h4>
<p>我们从注释中找到这样的信息, 可以作为参考</p>
<pre class="prettyprint linenums"><code>bit       result<br />
=================<br />
0x0    =&gt; NORMAL<br />
0x1    =&gt; DMA or NORMAL<br />
0x2    =&gt; HIGHMEM or NORMAL<br />
0x3    =&gt; BAD (DMA+HIGHMEM)<br />
0x4    =&gt; DMA32 or DMA or NORMAL<br />
0x5    =&gt; BAD (DMA+DMA32)<br />
0x6    =&gt; BAD (HIGHMEM+DMA32)<br />
0x7    =&gt; BAD (HIGHMEM+DMA32+DMA)<br />
0x8    =&gt; NORMAL (MOVABLE+0)<br />
0x9    =&gt; DMA or NORMAL (MOVABLE+DMA)<br />
0xa    =&gt; MOVABLE (Movable is valid only if HIGHMEM is set too)<br />
0xb    =&gt; BAD (MOVABLE+HIGHMEM+DMA)<br />
0xc    =&gt; DMA32 (MOVABLE+DMA32)<br />
0xd    =&gt; BAD (MOVABLE+DMA32+DMA)<br />
0xe    =&gt; BAD (MOVABLE+DMA32+HIGHMEM)<br />
0xf    =&gt; BAD (MOVABLE+DMA32+HIGHMEM+DMA)

GFP_ZONES_SHIFT must be &lt;= 2 on 32 bit platforms.<br />
</code></pre>
<p>很有趣的一点是，没有__GFP_NORMAL常数，而内存分配的主要负担却落到ZONE_NORMAL内存域</p>
<p>内核考虑到这一点, 提供了一个函数gfp_zone来计算与给定分配标志兼容的最高内存域. 那么内存分配可以从该内存域或更低的内存域进行, 该函数定义在<a href="https://elixir.bootlin.com/linux/v4.7/source/include/linux/gfp.h#L394" rel="external nofollow noreferrer">include/linux/gfp.h?v=4.7, line 394</a></p>
<pre class="prettyprint linenums"><code>#if defined(CONFIG_ZONE_DEVICE) &amp;&amp; (MAX_NR_ZONES-1) &lt;= 4<br />
/* ZONE_DEVICE is not a valid GFP zone specifier */<br />
#define GFP_ZONES_SHIFT 2<br />
#else<br />
#define GFP_ZONES_SHIFT ZONES_SHIFT<br />
#endif

#if 16 * GFP_ZONES_SHIFT &gt; BITS_PER_LONG<br />
#error GFP_ZONES_SHIFT too large to create GFP_ZONE_TABLE integer<br />
#endif<br />
</code></pre>
<p>由于内存域修饰符的解释方式不是那么直观, 表3-7给出了该函数结果的一个例子, 其中DMA和DMA32内存域相同. 假定在下文中没有设置__GFP_MOVABLE修饰符.</p>
<table>
<thead>
<tr>
<th>修饰符</th>
<th>扫描的内存域</th>
</tr>
</thead>
<tbody>
<tr>
<td>无</td>
<td>ZONE_NORMAL、ZONE_DMA</td>
</tr>
<tr>
<td>__GFP_DMA</td>
<td>ZONE_DMA</td>
</tr>
<tr>
<td>__GFP_DMA &amp; __GFP_HIGHMEM</td>
<td>ZONE_DMA</td>
</tr>
<tr>
<td>__GFP_HIGHMEM</td>
<td>ZONE_HIGHMEM、ZONE_NORMAL、ZONE_DMA</td>
</tr>
</tbody>
</table>
<ul><li>如果__GFP_DMA和__GFP_HIGHMEM都没有设置, 则首先扫描ZONE_NORMAL, 后面是ZONE_DMA</li>
<li>如果设置了__GFP_HIGHMEM没有设置__GFP_DMA，则结果是从ZONE_HIGHMEM开始扫描所有3个内存域。</li>
<li>如果设置了__GFP_DMA，那么__GFP_HIGHMEM设置与否没有关系. 只有ZONE_DMA用于3种情形. 这是合理的, 因为同时使用__GFP_HIGHMEM和__GFP_DMA没有意义. 高端内存从来都不适用于DMA</li></ul>
<p>设置__GFP_MOVABLE不会影响内核的决策，除非它与__GFP_HIGHMEM同时指定. 在这种情况下, 会使用特殊的虚拟内存域ZONE_MOVABLE满足内存分配请求. 对前文描述的内核的反碎片策略而言, 这种行为是必要的.</p>
<p>除了内存域修饰符之外, 掩码中还可以设置一些标志.</p>
<p>下图中给出了掩码的布局，以及与各个比特位置关联的常数. __GFP_DMA32出现了几次，因为它可能位于不同的地方.</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/811006/201812/811006-20181216181218613-503403579.png"></p>
<p>与内存域修饰符相反, 这些额外的标志并不限制从哪个物理内存段分配内存, 但确实可以改变分配器的行为. 例如, 它们可以修改查找空闲内存时的积极程度.</p>
<h3>4.3 分配页</h3>
<h4>4.3.1 内存分配统一到alloc_pages接口</h4>
<p>通过使用标志、内存域修饰符和各个分配函数，内核提供了一种非常灵活的内存分配体系.尽管如此, 所有接口函数都可以追溯到一个简单的基本函数(alloc_pages_node)</p>
<p>分配单页的函数alloc_page和__get_free_page, 还有__get_dma_pages是借助于宏定义的.</p>
<pre class="prettyprint linenums"><code>//  http://lxr.free-electrons.com/source/include/linux/gfp.h?v=4.7#L483<br />
#define alloc_page(gfp_mask) alloc_pages(gfp_mask, 0)

//  http://lxr.free-electrons.com/source/include/linux/gfp.h?v=4.7#L500<br />
#define __get_free_page(gfp_mask) \<br />
    __get_free_pages((gfp_mask), 0)`

//  http://lxr.free-electrons.com/source/include/linux/gfp.h?v=4.7#L503<br />
#define __get_dma_pages(gfp_mask, order) \<br />
    __get_free_pages((gfp_mask) | GFP_DMA, (order))<br />
</code></pre>
<p>get_zeroed_page的实现也没什么困难, 对__get_free_pages使用__GFP_ZERO标志，即可分配填充字节0的页. 再返回与页关联的内存区地址即可.</p>
<pre class="prettyprint linenums"><code>//  http://lxr.free-electrons.com/source/mm/page_alloc.c?v=4.7#L3900<br />
unsigned long get_zeroed_page(gfp_t gfp_mask)<br />
{<br />
        return __get_free_pages(gfp_mask | __GFP_ZERO, 0);<br />
}<br />
EXPORT_SYMBOL(get_zeroed_page);<br />
</code></pre>
<p>__get_free_pages调用alloc_pages完成内存分配, 而alloc_pages又借助于alloc_pages_node</p>
<p>__get_free_pages函数的定义在<a href="http://lxr.free-electrons.com/source/mm/page_alloc.c?v=4.7#L3883" rel="external nofollow noreferrer">mm/page_alloc.c?v=4.7, line 3883</a></p>
<pre class="prettyprint linenums"><code>//  http://lxr.free-electrons.com/source/mm/page_alloc.c?v=4.7#L3883<br />
unsigned long __get_free_pages(gfp_t gfp_mask, unsigned int order)<br />
{<br />
    struct page *page;

    /*<br />
     * __get_free_pages() returns a 32-bit address, which cannot represent<br />
     * a highmem page<br />
     */<br />
    VM_BUG_ON((gfp_mask &amp; __GFP_HIGHMEM) != 0);

    page = alloc_pages(gfp_mask, order);<br />
    if (!page)<br />
        return 0;<br />
    return (unsigned long) page_address(page);<br />
}<br />
EXPORT_SYMBOL(__get_free_pages);<br />
</code></pre>
<p>在这种情况下， 使用了一个普通函数而不是宏， 因为alloc_pages返回的page实例需要使用辅助</p>
<p>函数page_address转换为内存地址. 在这里，只要知道该函数可根据page实例计算相关页的线性内存地址即可. 对高端内存页这是有问题的</p>
<p>这样, 就完成了所有分配内存的API函数到公共的基础函数alloc_pages的统一</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/811006/201812/811006-20181216181544642-809174523.png"></p>
<p>所有体系结构都必须实现的标准函数clear_page, 可帮助alloc_pages对页填充字节0, 实现如下表所示</p>
<table>
<thead>
<tr>
<th>x86</th>
<th>arm</th>
</tr>
</thead>
<tbody>
<tr>
<td>arch/x86/include/asm/page_32.h?v=4.7, line 24</td>
<td>arch/arm/include/asm/page.h?v=4.7#L14 <br> arch/arm/include/asm/page-nommu.h</td>
</tr>
</tbody>
</table>
<h4>4.3.2 alloc_pages函数分配页</h4>
<p>既然所有的内存分配API函数都可以追溯掉alloc_page函数, 从某种意义上说，该函数是伙伴系统主要实现的”发射台”.</p>
<p>alloc_pages函数的定义是依赖于NUMA或者UMA架构的, 定义如下</p>
<pre class="prettyprint linenums"><code>#ifdef CONFIG_NUMA

//  http://lxr.free-electrons.com/source/include/linux/gfp.h?v=4.7#L465<br />
static inline struct page *<br />
alloc_pages(gfp_t gfp_mask, unsigned int order)<br />
{<br />
        return alloc_pages_current(gfp_mask, order);<br />
}

#else

//  http://lxr.free-electrons.com/source/include/linux/gfp.h?v=4.7#L476<br />
#define alloc_pages(gfp_mask, order) \<br />
                alloc_pages_node(numa_node_id(), gfp_mask, order)<br />
#endif<br />
</code></pre>
<p>UMA结构下的alloc_pages是通过alloc_pages_node函数实现的, 下面我们看看alloc_pages_node函数的定义, 在<a href="https://elixir.bootlin.com/linux/v4.7/source/include/linux/gfp.h#L448" rel="external nofollow noreferrer">include/linux/gfp.h?v=4.7, line 448</a></p>
<pre class="prettyprint linenums"><code>//  http://lxr.free-electrons.com/source/include/linux/gfp.h?v=4.7#L448<br />
/*<br />
 * Allocate pages, preferring the node given as nid. When nid == NUMA_NO_NODE,<br />
 * prefer the current CPU's closest node. Otherwise node must be valid and<br />
 * online.<br />
 */<br />
static inline struct page *alloc_pages_node(int nid, gfp_t gfp_mask,<br />
                        unsigned int order)<br />
{<br />
    if (nid == NUMA_NO_NODE)<br />
        nid = numa_mem_id();

    return __alloc_pages_node(nid, gfp_mask, order);<br />
}<br />
</code></pre>
<p>内核假定传递给改alloc_pages_node函数的结点nid是被激活, 即online的.但是为了安全它还是检查并警告内存结点不存在的情况. 接下来的工作委托给__alloc_pages, 只需传递一组适当的参数, 其中包括节点nid的备用内存域列表zonelist.</p>
<p>现在__alloc_pages函数没什么特别的, 它直接将自己的所有信息传递给__alloc_pages_nodemask来完成内存的分配</p>
<pre class="prettyprint linenums"><code>//  http://lxr.free-electrons.com/source/include/linux/gfp.h?v=4.7#L428<br />
static inline struct page *<br />
__alloc_pages(gfp_t gfp_mask, unsigned int order,<br />
        struct zonelist *zonelist)<br />
{<br />
    return __alloc_pages_nodemask(gfp_mask, order, zonelist, NULL);<br />
}<br />
</code></pre>
<h4>4.3.3 伙伴系统的心脏__alloc_pages_nodemask</h4>
<p>内核源代码将__alloc_pages称之为”伙伴系统的心脏”(`the ‘heart’ of the zoned buddy allocator“), 因为它处理的是实质性的内存分配.</p>
<p>由于”心脏”的重要性, 我将在下文详细介绍该函数.</p>
<p>__alloc_pages函数定义在<a href="https://elixir.bootlin.com/linux/v4.7/source/include/linux/gfp.h#L428" rel="external nofollow noreferrer">include/linux/gfp.h?v=4.7#L428</a></p>
<pre class="prettyprint linenums"><code>//  http://lxr.free-electrons.com/source/mm/page_alloc.c?v=4.7#L3779<br />
/*<br />
 * This is the 'heart' of the zoned buddy allocator.<br />
 */<br />
struct page *<br />
__alloc_pages_nodemask(gfp_t gfp_mask, unsigned int order,<br />
            struct zonelist *zonelist, nodemask_t *nodemask)<br />
{<br />
    struct page *page;<br />
    unsigned int cpuset_mems_cookie;<br />
    unsigned int alloc_flags = ALLOC_WMARK_LOW|ALLOC_FAIR;<br />
    gfp_t alloc_mask = gfp_mask; /* The gfp_t that was actually used for allocation */<br />
    struct alloc_context ac = {<br />
        .high_zoneidx = gfp_zone(gfp_mask),<br />
        .zonelist = zonelist,<br />
        .nodemask = nodemask,<br />
        .migratetype = gfpflags_to_migratetype(gfp_mask),<br />
    };

    if (cpusets_enabled()) {<br />
        alloc_mask |= __GFP_HARDWALL;<br />
        alloc_flags |= ALLOC_CPUSET;<br />
        if (!ac.nodemask)<br />
            ac.nodemask = &amp;cpuset_current_mems_allowed;<br />
    }

    gfp_mask &amp;= gfp_allowed_mask;

    lockdep_trace_alloc(gfp_mask);

    might_sleep_if(gfp_mask &amp; __GFP_DIRECT_RECLAIM);

    if (should_fail_alloc_page(gfp_mask, order))<br />
        return NULL;

    /*<br />
     * Check the zones suitable for the gfp_mask contain at least one<br />
     * valid zone. It's possible to have an empty zonelist as a result<br />
     * of __GFP_THISNODE and a memoryless node<br />
     */<br />
    if (unlikely(!zonelist-&gt;_zonerefs-&gt;zone))<br />
        return NULL;

    if (IS_ENABLED(CONFIG_CMA) &amp;&amp; ac.migratetype == MIGRATE_MOVABLE)<br />
        alloc_flags |= ALLOC_CMA;

retry_cpuset:<br />
    cpuset_mems_cookie = read_mems_allowed_begin();

    /* Dirty zone balancing only done in the fast path */<br />
    ac.spread_dirty_pages = (gfp_mask &amp; __GFP_WRITE);

    /*<br />
     * The preferred zone is used for statistics but crucially it is<br />
     * also used as the starting point for the zonelist iterator. It<br />
     * may get reset for allocations that ignore memory policies.<br />
     */<br />
    ac.preferred_zoneref = first_zones_zonelist(ac.zonelist,<br />
                    ac.high_zoneidx, ac.nodemask);<br />
    if (!ac.preferred_zoneref) {<br />
        page = NULL;<br />
        goto no_zone;<br />
    }

    /* First allocation attempt */<br />
    page = get_page_from_freelist(alloc_mask, order, alloc_flags, &amp;ac);<br />
    if (likely(page))<br />
        goto out;

    /*<br />
     * Runtime PM, block IO and its error handling path can deadlock<br />
     * because I/O on the device might not complete.<br />
     */<br />
    alloc_mask = memalloc_noio_flags(gfp_mask);<br />
    ac.spread_dirty_pages = false;

    /*<br />
     * Restore the original nodemask if it was potentially replaced with<br />
     * &amp;cpuset_current_mems_allowed to optimize the fast-path attempt.<br />
     */<br />
    if (cpusets_enabled())<br />
        ac.nodemask = nodemask;<br />
    page = __alloc_pages_slowpath(alloc_mask, order, &amp;ac);

no_zone:<br />
    /*<br />
     * When updating a task's mems_allowed, it is possible to race with<br />
     * parallel threads in such a way that an allocation can fail while<br />
     * the mask is being updated. If a page allocation is about to fail,<br />
     * check if the cpuset changed during allocation and if so, retry.<br />
     */<br />
    if (unlikely(!page &amp;&amp; read_mems_allowed_retry(cpuset_mems_cookie))) {<br />
        alloc_mask = gfp_mask;<br />
        goto retry_cpuset;<br />
    }

out:<br />
    if (kmemcheck_enabled &amp;&amp; page)<br />
        kmemcheck_pagealloc_alloc(page, order, gfp_mask);

    trace_mm_page_alloc(page, order, alloc_mask, ac.migratetype);

    return page;<br />
}<br />
EXPORT_SYMBOL(__alloc_pages_nodemask);<br />
</code></pre>
<h3>4.4 __free_pages</h3>
<p>类似地，内存释放函数也可以归约到一个主要的函数(__free_pages), 只是用不同的参数调用而已</p>
<p>前面我们讲过内核释放的两个主要函数有__free_page和free_page, 它们的定义在<a href="http://lxr.free-electrons.com/source/include/linux/gfp.h?v=4.7#L519" rel="external nofollow noreferrer">include/linux/gfp.h?v=4.7#L519</a></p>
<pre class="prettyprint linenums"><code>void free_pages(unsigned long addr, unsigned int order)<br />
{<br />
    if (addr != 0) {<br />
        VM_BUG_ON(!virt_addr_valid((void *)addr));<br />
        __free_pages(virt_to_page((void *)addr), order);<br />
    }<br />
}<br />
</code></pre>
<p>free_pages和__free_pages之间的关系通过函数而不是宏建立, 因为首先必须将虚拟地址转换为指向struct page的指针</p>
<p>virt_to_page将虚拟内存地址转换为指向page实例的指针. 基本上, 这是讲解内存分配函数时介绍的page_address辅助函数的逆过程.</p>
<p>下图以图形化方式综述了各个内存释放函数之间的关系</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/811006/201812/811006-20181216182906547-2123807367.png"></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8ody2eq.html">Spring MVC&plus;FreeMarker简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2n70oq.html">启动Eclipse弹出：Failed to load JavaHL Library 错误框的解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/495l7p68.html">pythonpython-eggs异常解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kyrpr9.html">高版本jquery尤其是1&period;10&period;2的版本设置input radio设置值的最正确的姿势。</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jynlw9.html">mysql查询所有字段&lpar;&ast;&rpar;&comma;并且联表时需要特别注意的地方</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k106d39.html">LINQ TO DATATABLE&sol;DATASET基本操作之-简单查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mrzy1q.html">Protel 的自动推挤功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljvm6e9.html">eclipse在多modules项目结构下避免模块间依赖引用的场景</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjeyv28.html">SpringMVC之简单的增删改查示例（SSM整合）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1mdvjq.html">《java入门第一季》之面向对象（继承总结）</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gjxp6q.html">题解-TIOJ1905 最理想的身高差</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw37348.html">JS膏集04</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rwmzz8.html">laravel中消息通知功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7oje1e8.html">Java设计模式学习记录-迭代器模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4xr3z9.html">【读书笔记】iOS-配件</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gyymvq.html">slot 插槽的作用域用法&lpar;摘自vue&period;js 官网&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv2o1r8.html">webview定位 &amp;amp&semi; native和webview切换</a>
		</li>
						<li><a href="https://www.batexi.com/a/90220emq.html">为什么要有handler机制？handler机制的原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmmo009.html">VMware克隆虚拟机后无法启动网卡</a>
		</li>
						<li><a href="https://www.batexi.com/a/953mj0z8.html">linux常用命令：tar 命令</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/90mzmmm8.html">Java第二次上机随笔</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1m11mq.html">Linux如何配置想要的JDK</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzw10g8.html">Linux查看系统、核数、CPU、位数</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yewmr8.html">bootcamp分区&lowbar;BOOTCAMP 删除分区失败</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eynmnz9.html">并发编程（十一）&mdash;&mdash; Java 线程池 实现原理与源码深度解析（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojzv51q.html">通过Python、BeautifulSoup爬取Gitee热门开源项目</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mzj4j8.html">react~props和state的介绍与使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzwngw8.html">从0打卡leetcode之day 5 ---两个排序数组的中位数</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ge2doz8.html">补习系列&lpar;2&rpar;-springboot mime类型处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljgkde9.html">在&period;NET Core中使用简单的插件化机制</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
